<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\WealthCurrencyList;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class WealthCurrencyController extends Controller
{

    public function list()
    {
        try {

            $currency = WealthCurrencyList::orderBy('name', 'asc')->get();
            return response()->json([
                'success' => true,
                'data' => $currency,
            ]);
        } catch (\Exception $e) {

            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }

    public function delete($id)
    {
        try {
            $currency = WealthCurrencyList::findOrFail($id);
            if ($currency) {
                $currency->delete();
                return response()->json(['success' => true, 'message' => 'currency Deleted.']);
            } else {
                return response()->json(['success' => false, 'message' => 'currency `Not Found!']);
            }
        } catch (\Exception $e) {
            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }

    public function add(Request $request)
    {
        try {
            $request->validate([
                'name' => 'required',
                'code' => 'required',
                'symbol' => 'required',
            ]);

            $currency = new WealthCurrencyList();

            $currency->name = $request->name;
            $currency->code = $request->code;
            $currency->symbol = $request->symbol;

            $currency->save();

            return response()->json([
                'success' => true,
                'message' => 'Currency Inserted Successfully',
                'data' => $currency,
            ]);
        } catch (\Exception $e) {
            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }


}
