<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\WealthAccountUser;
use App\Models\WealthCategory;
use App\Models\WealthTransaction;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class WealthTransactionController extends Controller
{

    /* APP API */
    public function add(Request $request)
    {
        try {
            $request->validate([
                'user_id' => 'required',
                'amount' => 'required',
                'transaction_date' => 'required',
                'category_id' => 'required',
                'account_id' => 'required',
                'transaction_type' => 'required',
                'repeat_transaction' => 'required',
            ]);

            $path1 = '';
            $path2 = '';
            $path3 = '';
            if ($request->image_1 && $request->image_1->isValid()) {
                $path1 = $this->fileUploadApi('transaction', $request->file('image_1'));
            }

            if ($request->image_2 && $request->image_2->isValid()) {
                $path2 = $this->fileUploadApi('transaction', $request->file('image_2'));
            }

            if ($request->image_3 && $request->image_3->isValid()) {
                $path3 = $this->fileUploadApi('transaction', $request->file('image_3'));
            }

            $repeat_transaction = $request->repeat_transaction;
            $trasactionDate = $request->transaction_date . ' ' . date('H:i:s');

            if (isset($repeat_transaction) && $repeat_transaction > 0) {
                $date1 = date_create($request->transaction_date);
                $date2 = date_create(date('Y-m-d'));
                $diff = date_diff($date1, $date2);

                if ($repeat_transaction == 1) {
                    $count = $diff->days;
                    for ($i = 0; $i <= $count; $i++) {
                        $newDate = strtotime($trasactionDate . '+ ' . $i . ' day');
                        $transaction = new WealthTransaction();
                        $transaction->user_id = $request->user_id;
                        $transaction->amount = $request->amount;
                        $transaction->category_id = $request->category_id;
                        $transaction->account_id = $request->account_id;
                        $transaction->transaction_date = date('Y-m-d H:i:s', $newDate);
                        if ($i == 0) {
                            $transaction->repeat_transaction = $request->repeat_transaction;
                        } else {
                            $transaction->repeat_transaction = 0;
                        }
                        $transaction->comment = $request->comment;
                        $transaction->image_1 = $path1;
                        $transaction->image_2 = $path2;
                        $transaction->image_3 = $path3;
                        $transaction->transaction_type = strtoupper($request->transaction_type);

                        $transaction->save();
                    }
                } elseif ($repeat_transaction == 2) {
                    $count = ($diff->days % 7);
                    for ($i = 0; $i <= $count; $i++) {
                        $newDate = strtotime($trasactionDate . '+ ' . ($i * 7) . ' day');
                        $transaction = new WealthTransaction();
                        $transaction->user_id = $request->user_id;
                        $transaction->amount = $request->amount;
                        $transaction->category_id = $request->category_id;
                        $transaction->account_id = $request->account_id;
                        $transaction->transaction_date = date('Y-m-d H:i:s', $newDate);
                        if ($i == 0) {
                            $transaction->repeat_transaction = $request->repeat_transaction;
                        } else {
                            $transaction->repeat_transaction = 0;
                        }
                        $transaction->comment = $request->comment;
                        $transaction->image_1 = $path1;
                        $transaction->image_2 = $path2;
                        $transaction->image_3 = $path3;
                        $transaction->transaction_type = strtoupper($request->transaction_type);

                        $transaction->save();
                    }
                } elseif ($repeat_transaction == 3) {
                    $count = ($diff->days % 14);
                    for ($i = 0; $i <= $count; $i++) {
                        $newDate = strtotime($trasactionDate . '+ ' . ($i * 14) . ' day');
                        $transaction = new WealthTransaction();
                        $transaction->user_id = $request->user_id;
                        $transaction->amount = $request->amount;
                        $transaction->category_id = $request->category_id;
                        $transaction->account_id = $request->account_id;
                        $transaction->transaction_date = date('Y-m-d H:i:s', $newDate);
                        if ($i == 0) {
                            $transaction->repeat_transaction = $request->repeat_transaction;
                        } else {
                            $transaction->repeat_transaction = 0;
                        }
                        $transaction->comment = $request->comment;
                        $transaction->image_1 = $path1;
                        $transaction->image_2 = $path2;
                        $transaction->image_3 = $path3;
                        $transaction->transaction_type = strtoupper($request->transaction_type);

                        $transaction->save();
                    }
                } elseif ($repeat_transaction == 4) {
                    $count = ($diff->y * 12) + $diff->m;
                    for ($i = 0; $i <= $count; $i++) {
                        $newDate = strtotime($trasactionDate . '+ ' . $i . ' month');
                        $transaction = new WealthTransaction();
                        $transaction->user_id = $request->user_id;
                        $transaction->amount = $request->amount;
                        $transaction->category_id = $request->category_id;
                        $transaction->account_id = $request->account_id;
                        $transaction->transaction_date = date('Y-m-d H:i:s', $newDate);
                        if ($i == 0) {
                            $transaction->repeat_transaction = $request->repeat_transaction;
                        } else {
                            $transaction->repeat_transaction = 0;
                        }
                        $transaction->comment = $request->comment;
                        $transaction->image_1 = $path1;
                        $transaction->image_2 = $path2;
                        $transaction->image_3 = $path3;
                        $transaction->transaction_type = strtoupper($request->transaction_type);

                        $transaction->save();
                    }
                } elseif ($repeat_transaction == 5) {
                    $count = (($diff->y * 12) + $diff->m) % 2;
                    for ($i = 0; $i <= $count; $i++) {
                        $newDate = strtotime($trasactionDate . '+ ' . ($i * 6) . ' month');
                        $transaction = new WealthTransaction();
                        $transaction->user_id = $request->user_id;
                        $transaction->amount = $request->amount;
                        $transaction->category_id = $request->category_id;
                        $transaction->account_id = $request->account_id;
                        $transaction->transaction_date = date('Y-m-d H:i:s', $newDate);
                        if ($i == 0) {
                            $transaction->repeat_transaction = $request->repeat_transaction;
                        } else {
                            $transaction->repeat_transaction = 0;
                        }
                        $transaction->comment = $request->comment;
                        $transaction->image_1 = $path1;
                        $transaction->image_2 = $path2;
                        $transaction->image_3 = $path3;
                        $transaction->transaction_type = strtoupper($request->transaction_type);

                        $transaction->save();
                    }
                } elseif ($repeat_transaction == 6) {
                    $count = $diff->y;
                    for ($i = 0; $i <= $count; $i++) {
                        $newDate = strtotime($trasactionDate . '+ ' . $i . ' year');
                        $transaction = new WealthTransaction();
                        $transaction->user_id = $request->user_id;
                        $transaction->amount = $request->amount;
                        $transaction->category_id = $request->category_id;
                        $transaction->account_id = $request->account_id;
                        $transaction->transaction_date = date('Y-m-d H:i:s', $newDate);
                        if ($i == 0) {
                            $transaction->repeat_transaction = $request->repeat_transaction;
                        } else {
                            $transaction->repeat_transaction = 0;
                        }
                        $transaction->comment = $request->comment;
                        $transaction->image_1 = $path1;
                        $transaction->image_2 = $path2;
                        $transaction->image_3 = $path3;
                        $transaction->transaction_type = strtoupper($request->transaction_type);

                        $transaction->save();
                    }
                }
            } else {
                $transaction = new WealthTransaction();
                $transaction->user_id = $request->user_id;
                $transaction->amount = $request->amount;
                $transaction->category_id = $request->category_id;
                $transaction->account_id = $request->account_id;
                $transaction->transaction_date = $request->transaction_date . ' ' . date('H:i:s');
                $transaction->repeat_transaction = $request->repeat_transaction;
                $transaction->comment = $request->comment;
                $transaction->image_1 = $path1;
                $transaction->image_2 = $path2;
                $transaction->image_3 = $path3;
                $transaction->transaction_type = strtoupper($request->transaction_type);

                $transaction->save();
            }

            return response()->json([
                'success' => true,
                'msg' => 'Trasaction added successfully',
            ]);
        } catch (\Exception $e) {

            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }

    public function listByDate(Request $request)
    {
        try {
            $request->validate([
                'user_id' => 'required',
                'transaction_type' => 'required'
            ]);

            $total = 0;
            $account = WealthAccountUser::where('user_id', $request->user_id)->get();

            if (isset($account) && count($account) > 0) {
                foreach ($account as $key => $val) {
                    if ($val->add_to_total == 'Y') {
                        $total += $val->amount;
                    }
                }
            }

            if (isset($request->date_form, $request->date_to) && $request->date_form != '' && $request->date_to != '') {
                $startDate = Carbon::createFromFormat('Y-m-d', $request->date_form)->startOfDay();
                $endDate = Carbon::createFromFormat('Y-m-d', $request->date_to)->endOfDay();
            } else {
                $transactionFirst = WealthTransaction::Select('transaction_date')
                    ->where('user_id', $request->user_id)
                    ->orderBy('transaction_date', 'asc')
                    ->first();

                $startingInputDate = date('Y-m-d', strtotime($transactionFirst->transaction_date));
                $startDate = Carbon::createFromFormat('Y-m-d', $startingInputDate)->startOfDay();
                $endDate = Carbon::createFromFormat('Y-m-d', date('Y-m-d'))->endOfDay();
            }



            $totalTransaction = WealthTransaction::where('transaction_type', strtoupper($request->transaction_type))
                ->where('user_id', $request->user_id)
                ->whereBetween('transaction_date', [$startDate, $endDate])
                ->sum('amount');

            $transaction = WealthTransaction::with('category')
                ->select(DB::raw('sum(amount) as amount'), 'category_id')
                ->where('transaction_type', strtoupper($request->transaction_type))
                ->where('user_id', $request->user_id)
                ->whereBetween('transaction_date', [$startDate, $endDate])
                ->orderBy('transaction_date', 'desc')
                ->groupBY('category_id')
                ->get();


            if (isset($transaction) && count($transaction) > 0) {
                //$history = array('totalBalance' => $total);
                foreach ($transaction as $key => $val) {
                    $history['recordData'][$key]['amount'] = $val->amount;
                    $history['recordData'][$key]['category_id'] = $val->category->id;
                    $history['recordData'][$key]['category_name'] = $val->category->title;
                    $history['recordData'][$key]['icon'] = $val->category->icon;
                    $history['recordData'][$key]['color'] = $val->category->color;
                    $history['recordData'][$key]['percentage'] = round(($val->amount / $totalTransaction) * 100);
                }

                return response()->json([
                    'success' => true,
                    'data' => $history['recordData'],
                ]);
            } else {
                return response()->json(['success' => false, 'message' => 'No transaction found']);
            }
        } catch (\Exception $e) {

            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }

    public function listByDateAccount(Request $request)
    {
        try {
            $request->validate([
                'date_form' => 'required',
                'date_to' => 'required',
                'user_id' => 'required',
                'transaction_type' => 'required'
            ]);

            $total = 0;
            $account = WealthAccountUser::where('user_id', $request->user_id)->get();

            if (isset($account) && count($account) > 0) {
                foreach ($account as $key => $val) {
                    if ($val->add_to_total == 'Y') {
                        $total += $val->amount;
                    }
                }
            }


            $startDate = Carbon::createFromFormat('Y-m-d', $request->date_form)->startOfDay();
            $endDate = Carbon::createFromFormat('Y-m-d', $request->date_to)->endOfDay();

            $totalTransaction = WealthTransaction::where('transaction_type', strtoupper($request->transaction_type))
                ->where('user_id', $request->user_id)
                ->whereBetween('transaction_date', [$startDate, $endDate])
                ->sum('amount');

            $transaction = WealthTransaction::with('account')
                ->select(DB::raw('sum(amount) as amount'), 'account_id')
                ->where('transaction_type', strtoupper($request->transaction_type))
                ->where('user_id', $request->user_id)
                ->whereBetween('transaction_date', [$startDate, $endDate])
                ->orderBy('transaction_date', 'desc')
                ->groupBY('account_id')
                ->get();


            if (isset($transaction) && count($transaction) > 0) {
                //$history = array('totalBalance' => $total);
                foreach ($transaction as $key => $val) {
                    $history['recordData'][$key]['amount'] = $val->amount;
                    $history['recordData'][$key]['account_name'] = $val->account->title;
                    $history['recordData'][$key]['percentage'] = round(($val->amount / $totalTransaction) * 100);
                }

                return response()->json([
                    'success' => true,
                    'data' => $history['recordData'],
                ]);
            } else {
                return response()->json(['success' => false, 'message' => 'No transaction found']);
            }
        } catch (\Exception $e) {

            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }

    public function listByCategory(Request $request)
    {
        try {
            $request->validate([
                'user_id' => 'required',
                'transaction_type' => 'required',
                'category_id' => 'required'
            ]);

            if (isset($request->date_form, $request->date_to) && $request->date_form != '' && $request->date_to != '') {
                $startingInputDate = $request->date_form;
                $date1 = date_create($request->date_form);
                $date2 = date_create($request->date_to);
                $diff = date_diff($date1, $date2);

                $endInputDate = $request->date_to;

                $count = $diff->days;
            } else {
                $transactionFirst = WealthTransaction::Select('transaction_date')
                    ->where('user_id', $request->user_id)
                    ->orderBy('transaction_date', 'asc')
                    ->first();

                $startingInputDate = date('Y-m-d', strtotime($transactionFirst->transaction_date));
                $date1 = date_create($startingInputDate);
                $date2 = date_create(date('Y-m-d'));
                $diff = date_diff($date1, $date2);

                $endInputDate = date('Y-m-d');

                $count = $diff->days;
            }

            $category = WealthCategory::select('title')->where('id', $request->category_id)->first();
            $history = array(
                'category' => $category->title,
            );
            $listCount = 0;
            for ($i = 0; $i <= $count; $i++) {
                $newDate = date('Y-m-d', strtotime($endInputDate . ' - ' . $i . ' day'));
                $startDate = Carbon::createFromFormat('Y-m-d', $newDate)->startOfDay();
                $endDate = Carbon::createFromFormat('Y-m-d', $newDate)->endOfDay();

                $totalAmt = 0;

                $transaction = WealthTransaction::with('category')->with('account')
                    ->where('transaction_type', strtoupper($request->transaction_type))
                    ->where('user_id', $request->user_id)
                    ->where('category_id', $request->category_id)
                    ->whereBetween('transaction_date', [$startDate, $endDate])
                    ->orderBy('transaction_date', 'desc')
                    ->get();

                if (isset($transaction) && count($transaction) > 0) {
                    $history['recordData'][$listCount]['date'] = $newDate;
                    foreach ($transaction as $key => $val) {
                        $totalAmt = $totalAmt + $val->amount;
                        $history['recordData'][$listCount]['transaction'][$key]['transaction_id'] = $val->id;
                        $history['recordData'][$listCount]['transaction'][$key]['date'] = $val->transaction_date;
                        $history['recordData'][$listCount]['transaction'][$key]['amount'] = $val->amount;
                        $history['recordData'][$listCount]['transaction'][$key]['category_name'] = $val->category->title;
                        $history['recordData'][$listCount]['transaction'][$key]['icon'] = $val->category->icon;
                        $history['recordData'][$listCount]['transaction'][$key]['color'] = $val->category->color;
                        $history['recordData'][$listCount]['transaction'][$key]['account_name'] = $val->account->title;
                        $history['recordData'][$listCount]['transaction'][$key]['comment'] = $val->comment;
                        $history['recordData'][$listCount]['transaction'][$key]['image_1'] = $val->image_1;
                        $history['recordData'][$listCount]['transaction'][$key]['image_2'] = $val->image_2;
                        $history['recordData'][$listCount]['transaction'][$key]['image_3'] = $val->image_3;
                    }
                    $history['recordData'][$listCount]['total_amount'] = $totalAmt;

                    $listCount++;
                }
            }

            return response()->json([
                'success' => true,
                'data' => $history,
            ]);
        } catch (\Exception $e) {

            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }

    public function listByAccount(Request $request)
    {
        try {
            $request->validate([
                'date_form' => 'required',
                'date_to' => 'required',
                'user_id' => 'required',
                'transaction_type' => 'required',
                'account_id' => 'required'
            ]);

            $date1 = date_create($request->date_form);
            $date2 = date_create($request->date_to);
            $diff = date_diff($date1, $date2);

            $count = $diff->days;

            $account = WealthAccountUser::select('title')->where('id', $request->account_id)->first();
            $history = array(
                'account' => $account->title,
            );
            $listCount = 0;
            for ($i = 0; $i <= $count; $i++) {
                $newDate = date('Y-m-d', strtotime($request->date_form . ' + ' . $i . ' day'));
                $startDate = Carbon::createFromFormat('Y-m-d', $newDate)->startOfDay();
                $endDate = Carbon::createFromFormat('Y-m-d', $newDate)->endOfDay();

                $totalAmt = 0;

                $transaction = WealthTransaction::with('category')->with('account')
                    ->where('transaction_type', strtoupper($request->transaction_type))
                    ->where('user_id', $request->user_id)
                    ->where('account_id', $request->account_id)
                    ->whereBetween('transaction_date', [$startDate, $endDate])
                    ->orderBy('transaction_date', 'desc')
                    ->get();

                if (isset($transaction) && count($transaction) > 0) {
                    $history['recordData'][$listCount]['date'] = $newDate;
                    foreach ($transaction as $key => $val) {
                        $totalAmt = $totalAmt + $val->amount;
                        $history['recordData'][$listCount]['transaction'][$key]['transaction_id'] = $val->id;
                        $history['recordData'][$listCount]['transaction'][$key]['date'] = $val->transaction_date;
                        $history['recordData'][$listCount]['transaction'][$key]['amount'] = $val->amount;
                        $history['recordData'][$listCount]['transaction'][$key]['category_name'] = $val->category->title;
                        $history['recordData'][$listCount]['transaction'][$key]['icon'] = $val->category->icon;
                        $history['recordData'][$listCount]['transaction'][$key]['color'] = $val->category->color;
                        $history['recordData'][$listCount]['transaction'][$key]['account_name'] = $val->account->title;
                        $history['recordData'][$listCount]['transaction'][$key]['comment'] = $val->comment;
                        $history['recordData'][$listCount]['transaction'][$key]['image_1'] = $val->image_1;
                        $history['recordData'][$listCount]['transaction'][$key]['image_2'] = $val->image_2;
                        $history['recordData'][$listCount]['transaction'][$key]['image_3'] = $val->image_3;
                    }
                    $history['recordData'][$listCount]['total_amount'] = $totalAmt;

                    $listCount++;
                }
            }

            return response()->json([
                'success' => true,
                'data' => $history,
            ]);
        } catch (\Exception $e) {

            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }

    public function list(Request $request)
    {
        try {
            $request->validate([
                /* 'date_form' => 'required',
                'date_to' => 'required', */
                'user_id' => 'required',
            ]);

            if (isset($request->date_form, $request->date_to) && $request->date_form != '' && $request->date_to != '') {
                $startingInputDate = $request->date_form;
                $date1 = date_create($request->date_form);
                $date2 = date_create($request->date_to);
                $endInputDate = $request->date_to;
                $diff = date_diff($date1, $date2);

                $count = $diff->days;
            } else {
                $transactionFirst = WealthTransaction::Select('transaction_date')
                    ->where('user_id', $request->user_id)
                    ->orderBy('transaction_date', 'asc')
                    ->first();

                $startingInputDate = date('Y-m-d', strtotime($transactionFirst->transaction_date));
                $date1 = date_create($startingInputDate);
                $date2 = date_create(date('Y-m-d'));

                $endInputDate = date('Y-m-d');
                $diff = date_diff($date1, $date2);

                $count = $diff->days;
            }

            $history = array();
            $listCount = 0;

            $totalIncome = 0;
            $totalExpense = 0;

            for ($i = 0; $i <= $count; $i++) {
                $newDate = date('Y-m-d', strtotime($endInputDate . ' - ' . $i . ' day'));
                $startDate = Carbon::createFromFormat('Y-m-d', $newDate)->startOfDay();
                $endDate = Carbon::createFromFormat('Y-m-d', $newDate)->endOfDay();

                $totalAmt = 0;

                $transaction = WealthTransaction::with('category')->with('account')
                    ->where('user_id', $request->user_id)
                    ->whereBetween('transaction_date', [$startDate, $endDate])
                    ->orderBy('transaction_date', 'desc')
                    ->get();

                if (isset($transaction) && count($transaction) > 0) {
                    $history['recordData'][$listCount]['date'] = $newDate;
                    foreach ($transaction as $key => $val) {
                        if (isset($val->transaction_type) && strtoupper($val->transaction_type) == 'INCOME') {
                            $totalAmt = $totalAmt + $val->amount;
                            $totalIncome = $totalIncome + $val->amount;
                        } else {
                            $totalAmt = $totalAmt - $val->amount;
                            $totalExpense = $totalExpense + $val->amount;
                        }
                        $history['recordData'][$listCount]['transaction'][$key]['transaction_id'] = $val->id;
                        $history['recordData'][$listCount]['transaction'][$key]['date'] = $val->transaction_date;
                        $history['recordData'][$listCount]['transaction'][$key]['type'] = $val->transaction_type;
                        $history['recordData'][$listCount]['transaction'][$key]['amount'] = $val->amount;
                        $history['recordData'][$listCount]['transaction'][$key]['category_name'] = $val->category->title;
                        $history['recordData'][$listCount]['transaction'][$key]['icon'] = $val->category->icon;
                        $history['recordData'][$listCount]['transaction'][$key]['color'] = $val->category->color;
                        $history['recordData'][$listCount]['transaction'][$key]['account_name'] = $val->account->title;
                        $history['recordData'][$listCount]['transaction'][$key]['comment'] = $val->comment;
                        $history['recordData'][$listCount]['transaction'][$key]['image_1'] = $val->image_1;
                        $history['recordData'][$listCount]['transaction'][$key]['image_2'] = $val->image_2;
                        $history['recordData'][$listCount]['transaction'][$key]['image_3'] = $val->image_3;
                    }
                    $history['recordData'][$listCount]['total_amount'] = $totalAmt;
                    $listCount++;
                }
            }
            if (isset($history) && count($history) > 0) {
                $history['total_income'] = $totalIncome;
                $history['total_expense'] = $totalExpense;

                return response()->json([
                    'success' => true,
                    'data' => $history,
                ]);
            } else {
                return response()->json(['success' => false, 'message' => 'No data found']);
            }
        } catch (\Exception $e) {

            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }


    public function single(Request $request)
    {
        try {
            $request->validate([
                'id' => 'required'
            ]);

            $transaction = WealthTransaction::where('id', $request->id)->with('category')->with('account')->first();

            if (isset($transaction->id) && $transaction->id > 0) {

                return response()->json([
                    'success' => true,
                    'data' => $transaction,
                ]);
            } else {
                return response()->json(['success' => false, 'message' => 'No transaction found']);
            }
        } catch (\Exception $e) {

            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }

    public function update(Request $request)
    {
        try {
            $request->validate([
                'user_id' => 'required',
                'amount' => 'required',
                'transaction_date' => 'required',
                'category_id' => 'required',
                'account_id' => 'required',
                'transaction_type' => 'required',
                'id' => 'required',
            ]);

            $oldTrans = WealthTransaction::where('id', $request->id)->first();

            if (isset($oldTrans->id) && $oldTrans->id > 0) {

                $transaction = WealthTransaction::findOrFail($request->id);
                $path1 = '';
                $path2 = '';
                $path3 = '';
                if ($request->image_1 && $request->image_1->isValid()) {
                    $path1 = $this->fileUploadApi('transaction', $request->file('image_1'));
                    $transaction->image_1 = $path1;
                }

                if ($request->image_2 && $request->image_2->isValid()) {
                    $path2 = $this->fileUploadApi('transaction', $request->file('image_2'));
                    $transaction->image_2 = $path2;
                }

                if ($request->image_3 && $request->image_3->isValid()) {
                    $path3 = $this->fileUploadApi('transaction', $request->file('image_3'));
                    $transaction->image_3 = $path3;
                }

                $transaction->user_id = $request->user_id;
                $transaction->amount = $request->amount;
                $transaction->category_id = $request->category_id;
                $transaction->account_id = $request->account_id;
                $transaction->transaction_date = $request->transaction_date . ' ' . date('H:i:s');
                $transaction->comment = $request->comment;
                $transaction->transaction_type = strtoupper($request->transaction_type);

                $transaction->save();

                return response()->json([
                    'success' => true,
                    'msg' => 'Transaction updated successfully',
                ]);
            }
        } catch (\Exception $e) {

            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }

    public function delete(Request $request)
    {
        try {
            $request->validate([
                'id' => 'required',
            ]);

            $oldTrans = WealthTransaction::findOrFail($request->id);

            $oldTrans->delete();

            return response()->json(['success' => true, 'message' => 'successfully deleted']);
        } catch (\Exception $e) {

            return response()->json(['success' => false, 'message' => $e->getMessage()]);
        }
    }

    function fileUploadApi($path, $file)
    {
        $filename = pathinfo($file->getClientOriginalName(), PATHINFO_FILENAME);
        $imageName = $filename . rand(1000, 99999) . time() . '.' . $file->getClientOriginalExtension();
        $file->move(base_path() . '/public/' . $path, $imageName);
        return url('/') . '/' . $path . '/' . $imageName;
    }
}
