@extends('layouts.app')

@section('content')
    <div class="container-fluid">
        <!-- row -->
        <div class="row">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header">
                        <h4 class="card-title">Ads</h4>
                    </div>
                    <div class="card-body">
                        <div class="basic-form">
                            <div id="response"></div>
                            <form class="form-valide-with-icon" id='ads'>
                                <div class="mb-3">
                                    <label class="col-sm-3 col-form-label">Image</label>
                                    <div class="input-group">
                                        <div class="form-file">
                                            <input type="file" name="image" accept="image/*"
                                                class="form-file-input form-control">
                                        </div>
                                    </div>
                                </div>
                                <div class="mb-3 row">
                                    <label class="col-sm-3 col-form-label">Link</label>
                                    <div class="col-sm-12">
                                        <input type="text" name="link" id="link" class="form-control"
                                            placeholder="Link">
                                    </div>
                                </div>
                                <button type="submit" class="btn me-2 btn-primary">Submit</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('script')
    <script>
        var token = sessionStorage.getItem('token');
        var url = "{{ env('APP_URL') }}";

        $('#ads').submit(function(event) {
            event.preventDefault();

            // var formData = $(this).serialize();
            var formData = new FormData(this);

            $.ajax({
                url: url + "/create-ads",
                type: 'POST',
                data: formData,
                success: function(data) {
                    if (data.success) {
                        $('form#ads').trigger("reset");
                        window.location = url + "/list-ads-view";
                    } else {
                        $('#response').html("<div class='alert alert-danger'>" + data
                            .message + "</div>");
                    }
                },
                cache: false,
                contentType: false,
                processData: false
            });
        });
    </script>
@endsection
