@extends('layouts.app')

@section('content')
<div class="container-fluid">
    <!-- row -->
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">Course Category</h4>
                </div>
                <div class="card-body">
                    <div class="basic-form">
                        <div id="response"></div>
                        <form class="form-valide-with-icon" id="course-category">
                            <div class="mb-3 row">
                                <label class="col-sm-3 col-form-label">Code</label>
                                <div class="col-sm-12">
                                    <input type="number" name="code" class="form-control" placeholder="code">
                                </div>
                            </div>
                            <div class="mb-3 row">
                                <label class="col-sm-3 col-form-label">Name</label>
                                <div class="col-sm-12">
                                    <input type="text" name="name" class="form-control" placeholder="name">
                                </div>
                            </div>
                            <button type="submit" class="btn me-2 btn-primary">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
<script>
    $(document).ready(function(){
            $('#course-category').submit(function(event){
                event.preventDefault();

                var formData = $(this).serialize();
                var url = "{{ env('APP_URL') }}";

                $.ajax({
                    url:url+"/create-course-category",
                    type:'POST',
                    data:formData,
                    success:function(data){
                        console.log(data);
                        if(data.success){
                            $('form#course-category').trigger("reset");
                            window.location = url+"/list-course-category-view";
                        }else{
                            $('#response').html("<div class='alert alert-danger'>"+data.message+"</div>");
                        }
                    }
                });
            });
        });
</script>
@endsection
