@extends('layouts.app')

@section('content')
    <div class="container-fluid">
        <!-- row -->
        <div class="row">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header">
                        <h4 class="card-title">Edit Holding User Type</h4>
                    </div>
                    <div class="card-body">
                        <div class="basic-form">
                            <div id="response"></div>
                            <form class="form-valide-with-icon needs-validation" id="update-holding-user-type">
                                <input type="number" id="id" name="id" class="form-control" placeholder="ID"
                                    hidden>
                                    <div class="mb-3 row">
                                        <label class="col-sm-3 col-form-label">Name</label>
                                        <div class="col-sm-12">
                                            <input type="text" id="title" name="title" class="form-control" placeholder="Enter Title">
                                        </div>
                                    </div>
                                    <div class="mb-3 row">
                                        <label class="col-sm-3 col-form-label">App Display Name</label>
                                        <div class="col-sm-12">
                                            <input type="text" id="display_name" name="display_name" class="form-control" placeholder="Enter App Display Name">
                                        </div>
                                    </div>
                                <button type="submit" class="btn me-2 btn-primary">Submit</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection


@section('script')
    <script>
        var token = sessionStorage.getItem('token');
        var url = "{{ env('APP_URL') }}";

        function editData() {
            $.ajax({
                type: "GET",
                url: url + "/edit-holding-user-type/{{ request()->id }}",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                headers: {
                    "Authorization": "Bearer " + token
                },
                success: function(msg) {
                    if (msg.success) {
                        $("#id").val(msg.data['id']);
                        $("#title").val(msg.data['title']);
                        $("#display_name").val(msg.data['display_name']);
                    }else if (msg.message == 'User is not Authenticated.') {
                        window.location = url + "/login-view";
                    } else {
                        $('#response').html("<div class='alert alert-danger'>" + msg.message + "</div>");
                    }
                }
            });
        }

        $('#update-holding-user-type').submit(function(event) {
            event.preventDefault();
            $('#response').html("");
            // var formData = $(this).serialize();
            var formData = new FormData(this);

            $.ajax({
                url: url + "/update-holding-user-type",
                type: 'POST',
                data: formData,
                success: function(data) {
                    if (data.success) {
                        $('form#update-holding-user-type').trigger("reset");
                        window.location = url+"/list-holding-user-type-view";
                    } else {
                        $('#response').html("<div class='alert alert-danger'>" + data.message +
                            "</div>");
                    }
                },
                cache: false,
                contentType: false,
                processData: false
            });
        });

        $(document).ready(function() {
            CheckSession();
            editData();
        });
    </script>
@endsection
