@extends('layouts.app')

@section('css')
<link href="./assets/vendor/datatables/css/jquery.dataTables.min.css" rel="stylesheet">
@endsection
@section('content')
<div class="container-fluid">

    <!-- row -->


    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">Insight</h4>
                </div>
                <div class="card-body">
                    <div class="table-responsive">
                        <table id="example3" class="display" style="min-width: 845px">
                            <thead>
                                <tr>
                                    <th>Id</th>
                                    <th>Title</th>
                                    <th>Images</th>
                                    <th>Category Name</th>
                                    <th>Description</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
@section('script')
    <script src="./assets/vendor/datatables/js/jquery.dataTables.min.js"></script>
    {{-- <script src="./assets/js/plugins-init/datatables.init.js"></script> --}}
    <script>
        var token = sessionStorage.getItem('token');
        var url = "{{ env('APP_URL') }}";

        function displayData() {

            $.ajax({
                type: "GET",
                url: url + "/list-insight",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                headers: {
                    "Authorization": "Bearer " + token
                },
                success: function(msg) {
                    console.log(msg);
                    if (msg.success) {
                        var json = msg.data.insight;
                        var row = '';
                        $.each(json, function(index, obj) {
                            var images = obj.insight_image; var html = '';
                            for (var i = 0, j = images.length; i < j; i++) {
                                html += "<div><img src='" + images[i].image + "' width='50'><br><a href='{{route('deleteInsightImage')}}?id="+images[i].id+"' class='text-danger'>Remove</a></div>"
                            }

                            row += '<tr><td> ' + obj.id + ' </td> <td> ' + obj.title + ' </td><td><div class="d-flex gap-2">'+html+'</div></td> <td> ' + obj.categories_name + ' </td> <td> ' + obj.description +
                                ' </td> <td><div class="d-flex"><a href="' + url +
                                '/edit-insight-view/' + obj.id +
                                '" class="btn btn-primary shadow btn-xs sharp me-1"><i class="fas fa-pencil-alt"></i></a><a data-id="' +
                                obj.id +
                                '" class="btn btn-danger shadow btn-xs sharp delete-cat"><i class="fa fa-trash"></i></a></div></td> </tr>';
                                
                                
                        });
                        $(".display tbody").html(row);
                        $('#example3').DataTable();
                    }else if (msg.message == 'User is not Authenticated.') {
                        window.location = url + "/login-view";
                    } else {
                        $('#response').html("<div class='alert alert-danger'>" + msg.message +
                            "</div>");
                    }
                }
            });

        }

        $("body").on("click", "#example3 .delete-cat", function() {
            var id = $(this).attr("data-id");
            $.ajax({
                type: "GET",
                url: url + "/delete-insight/" + id,
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function(msg) {
                    if (msg.success) {
                        $('#response').html("<div class='alert alert-success'>" + msg.message +
                            "</div>");
                        displayData();
                    } else {
                        $('#response').html("<div class='alert alert-danger'>" + msg.message +
                            "</div>");
                    }
                }
            });
        });

        $(document).ready(function() {
            CheckSession();
            displayData();
        });
    </script>
@endsection

