<!DOCTYPE html>
<html lang="en">

<head>

    @include('components.head')

    @yield('css')

</head>

<body>

    <div id="preloader">
        <div class="lds-ripple">
            <div>
            </div>
            <div></div>
        </div>
    </div>

    <div id="main-wrapper">

        @include('components.nav')

        @include('components.aside')

        <div class="content-body">
            <div id="response"></div>
            @yield('content')
        </div>
        @include('components.footer')
    </div>
    <!-- Required vendors -->
    <script src="{{ asset('assets/vendor/global/global.min.js') }}"></script>
    <script src="{{ asset('assets/vendor/jquery-nice-select/js/jquery.nice-select.min.js') }}"></script>

    <script src="{{ asset('assets/vendor/chart.js/Chart.bundle.min.js') }}"></script>

    <!-- Chart piety plugin files -->
    <script src="{{ asset('assets/vendor/peity/jquery.peity.min.js') }}"></script>

    <script src="{{ asset('assets/vendor/owl-carousel/owl.carousel.js') }}"></script>

    <script src="{{ asset('assets/js/custom.min.js') }}"></script>
    <script src="{{ asset('assets/js/dlabnav-init.js') }}"></script>
    <script src="{{ asset('assets/js/demo.js') }}"></script>
    <script src="{{ asset('assets/js/styleSwitcher.js') }}"></script>

    <script>
        function CheckSession() {
            var session = sessionStorage.getItem('token');
            var url = "{{ env('APP_URL') }}";
            if (session == '' || session == null) {
                window.location = url + "/login-view";
            }
        }

        function logout() {
            var token = sessionStorage.getItem('token');
            var url = "{{ env('APP_URL') }}";
            $.ajax({
                type: "GET",
                url: url + "/logout/",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                headers: {
                    "Authorization": "Bearer " + token
                },
                success: function(msg) {
                    if (msg.success) {
                        sessionStorage.removeItem('token');
                        window.location = url + "/";
                    } else if (msg.message == "User is not Authenticated.") {
                        window.location = url + "/login-view";
                    } else {
                        $('#response').html("<div class='alert alert-danger'>" + msg.message +
                            "</div>");
                    }
                }
            });

        }

        $(document).ready(function() {
            CheckSession();
        });
    </script>

    @yield('script')

</body>

</html>
