@extends('layouts.app')

@section('content')
    <div class="container-fluid">
        <!-- row -->
        <div class="row">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-header">
                        <h4 class="card-title">Edit News Category</h4>
                    </div>
                    <div class="card-body">
                        <div class="basic-form">
                            <div id="response"></div>
                            <form class="form-valide-with-icon needs-validation" id="update-news-category">
                                <input type="number" id="id" name="id" class="form-control" placeholder="ID"
                                    hidden>
                                <div class="mb-3 row">
                                    <label class="col-sm-3 col-form-label">Name</label>
                                    <div class="col-sm-12">
                                        <input type="text" id="name" name="name" class="form-control"
                                            placeholder="Name">
                                    </div>
                                </div>
                                <div class="mb-3 row">
                                    <label class="col-sm-3 col-form-label">Image</label>
                                    <div class="input-group">
                                        <div class="form-file">
                                            <input type="file" id="image" name="image" accept="image/*"
                                                class="form-file-input form-control">
                                            <img id="show-img" width="50" src="#" alt="" />
                                        </div>
                                    </div>
                                </div>
                                <button type="submit" class="btn me-2 btn-primary">Submit</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection


@section('script')
    <script>
        var token = sessionStorage.getItem('token');
        var url = "{{ env('APP_URL') }}";

        function editData() {
            $.ajax({
                type: "GET",
                url: url + "/edit-news-category/{{ request()->id }}",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                headers: {
                    "Authorization": "Bearer " + token
                },
                success: function(msg) {
                    if (msg.success) {
                        $("#id").val(msg.data['id']);
                        $("#name").val(msg.data['name']);
                        $("#show-img").attr('src', msg.data.image);
                    }else if (msg.message == 'User is not Authenticated.') {
                        window.location = url + "/login-view";
                    } else {
                        $('#response').html("<div class='alert alert-danger'>" + msg.message + "</div>");
                    }
                }
            });
        }

        $('#update-news-category').submit(function(event) {
            event.preventDefault();
            $('#response').html("");
            // var formData = $(this).serialize();
            var formData = new FormData(this);

            $.ajax({
                url: url + "/update-news-category",
                type: 'POST',
                data: formData,
                success: function(data) {
                    if (data.success) {
                        $('form#update-news-category').trigger("reset");
                        window.location = url+"/list-news-category-view";
                    } else {
                        $('#response').html("<div class='alert alert-danger'>" + data.message +
                            "</div>");
                    }
                },
                cache: false,
                contentType: false,
                processData: false
            });
        });

        $(document).ready(function() {
            CheckSession();
            editData();
        });
    </script>
@endsection
