@extends('layouts.app')

@section('content')
<div class="container-fluid">
    <!-- row -->
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">Edit News Count</h4>
                </div>
                <div class="card-body">
                    <div class="basic-form">
                        <div id="response"></div>
                        <form class="form-valide-with-icon needs-validation" id="update-news-count">
                            <input type="number" id="id" name="id" class="form-control" placeholder="ID" hidden>
                            <div class="mb-3 row">
                                <label class="col-sm-3 col-form-label">Poll Count</label>
                                <div class="col-sm-12">
                                    <input type="number" id="poll_count" name="poll_count" class="form-control" placeholder="Poll Count" min="0">
                                </div>
                            </div>
                            <div class="mb-3 row">
                                <label class="col-sm-3 col-form-label">Insight Count</label>
                                <div class="col-sm-12">
                                    <input type="number" id="insight_count" name="insight_count" class="form-control" placeholder="Insight Counts" min="0">
                                </div>
                            </div>
                            <div class="mb-3 row">
                                <label class="col-sm-3 col-form-label">Ads Count</label>
                                <div class="col-sm-12">
                                    <input type="number" id="ads_count" name="ads_count" class="form-control" placeholder="Ads Count" min="0">
                                </div>
                            </div>

                            <button type="submit" class="btn me-2 btn-primary">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection


@section('script')
<script>
    var token = sessionStorage.getItem('token');
    var url = "{{ env('APP_URL') }}";

    function editData() {
        $.ajax({
            type: "GET",
            url: url + "/edit-news-count/{{ request()->id }}",
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            headers: {
                "Authorization": "Bearer " + token
            },
            success: function(msg) {
                if (msg.success) {
                    $("#id").val(msg.data['id']);
                    $("#poll_count").val(msg.data['poll_count']);
                    $("#insight_count").val(msg.data['insight_count']);
                    $("#ads_count").val(msg.data['ads_count']);
                } else if (msg.message == 'User is not Authenticated.') {
                    window.location = url + "/login-view";
                } else {
                    $('#response').html("<div class='alert alert-danger'>" + msg.message + "</div>");
                }
            }
        });
    }

    $('#update-news-count').submit(function(event) {
        event.preventDefault();
        $('#response').html("");
        // var formData = $(this).serialize();
        var formData = new FormData(this);

        $.ajax({
            url: url + "/update-news-count",
            type: 'POST',
            data: formData,
            success: function(data) {
                if (data.success) {
                    //  $('form#update-news-count').trigger("reset");
                    //  window.location = url + "/edit-news-count-view/" + $("#id").val();
                    $('#response').html("<div class='alert alert-success'>Data Update Successfully</div>");
                } else {
                    $('#response').html("<div class='alert alert-danger'>" + data.message +
                        "</div>");
                }
            },
            cache: false,
            contentType: false,
            processData: false
        });
    });

    $(document).ready(function() {
        CheckSession();
        editData();
    });
</script>
@endsection