@extends('layouts.app')

@section('css')
    <link href="./assets/vendor/datatables/css/jquery.dataTables.min.css" rel="stylesheet">
@endsection
@section('content')
    <div class="container-fluid">

        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <h4 class="card-title">News</h4>
                    </div>
                    <div id="response"></div>
                    <div class="card-body">
                        <div class="table-responsive">
                            <table id="example3" class="display" style="min-width: 845px">
                                <thead>
                                    <tr>
                                        <th>Id</th>
                                        <th>Type</th>
                                        <th>Image</th>
                                        <th>Title</th>
                                        <th>Description</th>
                                        <th>News Category</th>
                                        <th>Action</th>
                                        <th>Notification</th>
                                    </tr>
                                </thead>
                                <tbody>

                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('script')
    <script src="./assets/vendor/datatables/js/jquery.dataTables.min.js"></script>
    {{-- <script src="./assets/js/plugins-init/datatables.init.js"></script> --}}
    <script>
        var token = sessionStorage.getItem('token');
        var url = "{{ env('APP_URL') }}";

        function displayData() {

            $.ajax({
                type: "GET",
                url: url + "/list-news",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                headers: {
                    "Authorization": "Bearer " + token
                },
                success: function(msg) {
                    // console.log(msg);
                    if (msg.success) {
                        var json = msg.data;
                        var row = '';
                        $.each(json, function(index, obj) {
                            var type = obj.article_type == 1 ? "News" : ( obj.article_type == 2 ? "Poll" : (obj.article_type == 3 ? "insight" : "Ads"));
                            var sendNoti = obj.article_type == 1 ? '<a data-id="'+obj.id +'" data-article="'+obj.article_type +'" class="btn btn-info btn-xs sendNotification">send notification</a>' : "";
                             row += '<tr><td> ' + (index+1) + ' </td><td><span class="bg-primary rounded text-white px-2">'+type+'</span></td> <td><img class="" width="35" src="'+obj.image+'" alt=""></td> <td> ' + obj.title +
                                ' </td><td>'+obj.description+'</td> <td>'+obj.categories_name+'</td> <td><div class="d-flex"><a href="' + url +
                                '/edit-news-view/' + obj.id +
                                '" class="btn btn-primary shadow btn-xs sharp me-1"><i class="fas fa-pencil-alt"></i></a><a data-id="' +
                                obj.id +'" data-article="'+obj.article_type +'" class="btn btn-danger shadow btn-xs sharp delete-news"><i class="fa fa-trash"></i></a></div></td><td>'+sendNoti+'</td> </tr>';
                        });
                        $(".display tbody").html(row);
                        $('#example3').DataTable();
                    } else if (msg.message == 'User is not Authenticated.') {
                        window.location = url + "/login-view";
                    } else {
                        $('#response').html("<div class='alert alert-danger'>" + msg.message +
                            "</div>");
                    }
                }
            });

        }

        $("body").on("click", "#example3 .delete-news", function() {
            var id = $(this).attr("data-id");
            var article = $(this).attr("data-article");
            $.ajax({
                type: "GET",
                url: url + "/delete-news/" + id+"/"+article,
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function(msg) {
                    if (msg.success) {
                        $('#response').html("<div class='alert alert-success'>" + msg.message +
                            "</div>");
                        displayData();
                    } else {
                        $('#response').html("<div class='alert alert-danger'>" + msg.message +
                            "</div>");
                    }
                }
            });
        });

        $("body").on("click", "#example3 .sendNotification", function() {
            var id = $(this).attr("data-id");
            var article = $(this).attr("data-article");
            $.ajax({
                type: "get",
                url: "{{route('sendFcmNotification')}}",
                data: {dataId:id,article_type:article},
                beforeSend:function(){$(this).attr("disabled",true);$(this).html("wait..."); },
                success: function (response) {
                    $(this).attr("disabled",false);
                    $(this).html("send notification");
                    alert("Notification sended");
                }
            });
        });

        $(document).ready(function() {
            CheckSession();
            displayData();
        });
    </script>
@endsection
